package edu.uci.ics.jung.algorithms.metrics;

import java.util.List;

public class Norm {

    public static double countMetricPEqual1(List<Double> vector1, List<Double> vector2){
        return countMetric(vector1, vector2, 1);
    }

    public static double countMetricPEqual2(List<Double> vector1, List<Double> vector2){
        return countMetric(vector1, vector2, 2);
    }

    public static double countMetricPEqual3(List<Double> vector1, List<Double> vector2){
        return countMetric(vector1, vector2, 3);
    }

    public static double countMetricPEqualN(List<Double> vector1, List<Double> vector2){
        int n = vector1.size();
        return countMetric(vector1, vector2, n);
    }

    public static double countMetricPEqualInf(List<Double> vector1, List<Double> vector2){
        return countMetric(vector1, vector2, Integer.MAX_VALUE);
    }

    public static double countMetric(List<Double> vector1, List<Double> vector2, int p){
        if(vector1.size() != vector2.size())
            throw new IllegalArgumentException("Porównywane wektory muszą być równoliczne!");
        if(p < 1)
            throw new IllegalArgumentException("Wartość p musi być większa od 0!");

        double sum = 0;

        for(int i = 0; i < vector1.size(); i++) {
            double xi = vector1.get(i);
            double yi = vector2.get(i);
            double diff = xi - yi;

            sum += Math.pow(diff, p);
        }

        return Math.pow(sum, (1.0/p));
    }
}
