package edu.uci.ics.jung.algorithms.metrics;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Collection;

public class Statistics {

    private static double[] collectionToDoubleArray(Collection<Double> values){
        return values
                .stream()
                .mapToDouble(Double::doubleValue)
                .toArray();
    }

    private static double[] collectionToIntArray(Collection<Integer> values){
        return values
                .stream()
                .mapToDouble(Integer::doubleValue)
                .toArray();
    }

    public static double mean(Collection<Double> values){
        return mean(collectionToDoubleArray(values));
    }
    public static double min(Collection<Double> values){
        return min(collectionToDoubleArray(values));
    }
    public static double max(Collection<Double> values){
        return max(collectionToDoubleArray(values));
    }
    public static double stdDev(Collection<Double> values){
        return stdDev(collectionToDoubleArray(values));
    }
    public static double mean(ArrayList<Integer> values){
        return mean(collectionToIntArray(values));
    }
    public static int min(ArrayList<Integer> values){
        return (int)min(collectionToIntArray(values));
}
    public static int max(ArrayList<Integer> values){
        return (int)max(collectionToIntArray(values));
    }
    public static int stdDev(ArrayList<Integer> values){
        return (int)stdDev(collectionToIntArray(values));
    }


    public static double mean(double[] values){
        double sum = 0;
        int count = 0;
        for(double v: values){
            sum+= v;
            count++;
        }
        return (sum/count);
    }

    public static double max(double[] values){
        double max = Double.NEGATIVE_INFINITY;
        for(double v: values){
            if(v > max)
                max = v;
        }
        return max;
    }

    public static double min(double[] values){
        double min = Double.POSITIVE_INFINITY;
        for(double v: values){
            if(v < min)
                min = v;
        }
        return min;
    }

    public static double stdDev(double values[])
    {
        double sum = 0.0;
        double standardDeviation = 0.0;
        for(double num : values) {
            sum += num;
        }
        double mean = mean(values);
        for(double num: values) {
            standardDeviation += Math.pow(num - mean, 2);
        }
        return Math.sqrt(standardDeviation/(values.length-1));
    }


}
