package pl.edu.wat.wcy.isi.szymonm.phd.graph.walk;

import edu.uci.ics.jung.graph.Graph;
import pl.edu.wat.wcy.isi.szymonm.phd.enums.graphs.NoteRepresentation;

import java.util.ArrayList;
import java.util.Random;

public class PureRandomWalkWithRandomStartNode extends BaseGraphWalkMethod<String, String> {

    public PureRandomWalkWithRandomStartNode(NoteRepresentation nodeType) {
        super(nodeType);
    }

    @Override
    protected String pickNextNode(Graph<String, String> graph, String currentNode) {
        int nodeCount = graph.getSuccessorCount(currentNode);
        Random random = new Random();
        int startVertexIndex = random.nextInt(nodeCount);
        ArrayList<String> vertices = new ArrayList<>(graph.getSuccessors(currentNode));
        return vertices.get(startVertexIndex);
    }

    @Override
    protected String pickStartNode(Graph<String, String> graph) {
        int nodeCount = graph.getVertexCount();
        Random random = new Random();
        int startVertexIndex = random.nextInt(nodeCount);
        ArrayList<String> vertices = new ArrayList<>(graph.getVertices());
        return vertices.get(startVertexIndex);
    }
}
