package pl.edu.wat.wcy.isi.szymonm.phd.visualisation.arrangement;

import edu.uci.ics.jung.algorithms.metrics.Norm;
import edu.uci.ics.jung.graph.Graph;
import pl.edu.wat.wcy.isi.szymonm.phd.enums.graphs.NoteRepresentation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.DirectedNetworkFullNotesCreation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.WeightedEdge;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.walk.EdgeDegreesWeightWalkWithSelectedStartNode;
import pl.edu.wat.wcy.isi.szymonm.phd.musicxml.Note;

import java.util.List;

public class EdgeDegreeRandomWalkArrangement {

    public static void main(String[] args) throws Exception {
        String filename;
        if(args.length == 0)
            filename = "HelloWorld.xml";
        else
            filename = args[0];

        DirectedNetworkFullNotesCreation networkFullNotesCreation = new DirectedNetworkFullNotesCreation();
        List<Note> originalNotes = networkFullNotesCreation.getNotesFromFile(filename);
        networkFullNotesCreation.displayGraph(originalNotes, filename);
        String firstNote = originalNotes.get(0).getNoteFullName();
        Graph<String, WeightedEdge> graph = networkFullNotesCreation.addNotesToNetwork(originalNotes);

        EdgeDegreesWeightWalkWithSelectedStartNode edgeDegreesControlledWalk
                = new EdgeDegreesWeightWalkWithSelectedStartNode(NoteRepresentation.Full, firstNote);
        List<Note> arrangementNotes = edgeDegreesControlledWalk.generateArrangement(graph, originalNotes.size());
        edgeDegreesControlledWalk.addNotesToFile(arrangementNotes, filename, 1);
        DirectedNetworkFullNotesCreation arrangementFullNotesCreation = new DirectedNetworkFullNotesCreation();
        Graph<String, WeightedEdge> arrangementGraph = arrangementFullNotesCreation.addNotesToNetwork(arrangementNotes);

        networkFullNotesCreation.displayGraph(arrangementNotes, filename + "- aranżacja");

        EdgeDegreeRandomWalkComparison.calculateAndDisplayDistance(networkFullNotesCreation, graph, arrangementFullNotesCreation, arrangementGraph);
    }
}
