package pl.edu.wat.wcy.isi.szymonm.phd.visualisation.arrangement;

import edu.uci.ics.jung.algorithms.metrics.Norm;
import edu.uci.ics.jung.graph.Graph;
import pl.edu.wat.wcy.isi.szymonm.phd.enums.graphs.NoteRepresentation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.BaseGraphNotesCreation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.DirectedNetworkFullNotesCreation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.WeightedEdge;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.walk.EdgeDegreesWeightWalkWithSelectedStartNode;
import pl.edu.wat.wcy.isi.szymonm.phd.musicxml.Note;

import java.util.List;

public class EdgeDegreeRandomWalkComparison {

    public static void main(String[] args) throws Exception {
        String filename;
        if(args.length == 0)
            filename = "FurElise.xml";
        else
            filename = args[0];
        String secondFileName;
        if(args.length < 2)
            // secondFileName = "FurElise_sample.xml";
            secondFileName = "RollingInTheDeep.xml";
        else
            secondFileName = args[1];

        DirectedNetworkFullNotesCreation networkFullNotesCreation = new DirectedNetworkFullNotesCreation();
        List<Note> originalNotes = networkFullNotesCreation.getNotesFromFile(filename);
        networkFullNotesCreation.displayGraph(originalNotes, filename);
        String firstNote = originalNotes.get(0).getNoteFullName();
        Graph<String, WeightedEdge> graph = networkFullNotesCreation.addNotesToNetwork(originalNotes);

        DirectedNetworkFullNotesCreation secondPieceNotesCreation = new DirectedNetworkFullNotesCreation();
        List<Note> secondPieceNotes = secondPieceNotesCreation.getNotesFromFile(secondFileName);
        //edgeDegreesControlledWalk.addNotesToFile(secondPieceNotes, secondFileName);
        Graph<String, WeightedEdge> arrangementGraph = secondPieceNotesCreation.addNotesToNetwork(secondPieceNotes);

        networkFullNotesCreation.displayGraph(secondPieceNotes, secondFileName);

        calculateAndDisplayDistance(networkFullNotesCreation, graph, secondPieceNotesCreation, arrangementGraph);
    }

    public static void calculateAndDisplayDistance(BaseGraphNotesCreation firstPieceNotes, Graph<String, ?> graph,
                                                   BaseGraphNotesCreation secondPieceNotes, Graph<String, ?> arrangementGraph) {
        List<Double> originalMetrics = firstPieceNotes.getGraphCharacteristics(graph);
        List<Double> arrangementMetrics = secondPieceNotes.getGraphCharacteristics(arrangementGraph);

        List<Double> originalMetricsNormalized = firstPieceNotes.getGraphCharacteristicsNormalized(graph);
        List<Double> arrangementMetricsNormalized = secondPieceNotes.getGraphCharacteristicsNormalized(arrangementGraph);

        System.out.println("Wektor miar utworu oryginalnego: " + originalMetrics.toString());
        System.out.println("Wektor miar utworu aranzowanego: " + arrangementMetrics.toString());
        System.out.println("Wektor miar znormalizowanych utworu oryginalnego: " + originalMetricsNormalized.toString());
        System.out.println("Wektor miar znormalizowanych utworu aranzowanego: " + arrangementMetricsNormalized.toString());
        System.out.println("Odległość między utworami: " + Norm.countMetricPEqual2(originalMetrics, arrangementMetrics));
        System.out.println("Odległość między utworami (miary znormalizowane): " + Norm.countMetricPEqual2(originalMetricsNormalized, arrangementMetricsNormalized));
    }
}
