package pl.edu.wat.wcy.isi.szymonm.phd.visualisation.arrangement;

import edu.uci.ics.jung.graph.Graph;
import pl.edu.wat.wcy.isi.szymonm.phd.enums.graphs.NoteRepresentation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.DirectedNetworkFullNotesCreation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.WeightedEdge;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.walk.EdgeDegreesWeightWalkWithSelectedStartNode;
import pl.edu.wat.wcy.isi.szymonm.phd.musicxml.Note;

import java.util.List;

public class EdgeDegreeRandomWalkMultipleArrangementGenerator {

    public static void generateArrangements(String fullFilePath, String filename, int arrangementsCount) throws Exception {

        DirectedNetworkFullNotesCreation networkFullNotesCreation = new DirectedNetworkFullNotesCreation();
        List<Note> originalNotes = networkFullNotesCreation.getNotesFromFile(fullFilePath);
        networkFullNotesCreation.displayGraph(originalNotes, filename);
        Graph<String, WeightedEdge> graph = networkFullNotesCreation.addNotesToNetwork(originalNotes);
        String firstNote = originalNotes.get(0).getNoteFullName();

        for (int i = 1; i <= arrangementsCount; i++) {

            EdgeDegreesWeightWalkWithSelectedStartNode edgeDegreesControlledWalk
                    = new EdgeDegreesWeightWalkWithSelectedStartNode(NoteRepresentation.Full, firstNote);
            List<Note> arrangementNotes = edgeDegreesControlledWalk.generateArrangement(graph, originalNotes.size());
            edgeDegreesControlledWalk.addNotesToFile(arrangementNotes, filename, i);
            DirectedNetworkFullNotesCreation arrangementFullNotesCreation = new DirectedNetworkFullNotesCreation();
            Graph<String, WeightedEdge> arrangementGraph = arrangementFullNotesCreation.addNotesToNetwork(arrangementNotes);

            networkFullNotesCreation.displayGraph(arrangementNotes, filename + "- aranżacja " + i);

            EdgeDegreeRandomWalkComparison.calculateAndDisplayDistance(networkFullNotesCreation, graph, arrangementFullNotesCreation, arrangementGraph);

        }
    }

}
