package pl.edu.wat.wcy.isi.szymonm.phd.visualisation.arrangement;

import edu.uci.ics.jung.algorithms.metrics.Norm;
import edu.uci.ics.jung.graph.Graph;
import pl.edu.wat.wcy.isi.szymonm.phd.enums.graphs.NoteRepresentation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.UndirectedGraphSimpleNotesCreation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.walk.PureRandomWalkWithRandomStartNode;
import pl.edu.wat.wcy.isi.szymonm.phd.musicxml.Note;

import java.util.List;

public class PureRandomWalkArrangement {

    public static void main(String[] args) throws Exception {
        String filename;
        if(args.length == 0)
            filename = "HelloWorld.xml";
        else
            filename = args[0];

        UndirectedGraphSimpleNotesCreation graphSimpleNotesCreation = new UndirectedGraphSimpleNotesCreation();
        List<Note> originalNotes = graphSimpleNotesCreation.getNotesFromFile(filename);
        graphSimpleNotesCreation.displayGraph(originalNotes, filename);

        Graph<String, String> graph = graphSimpleNotesCreation.addNotesToGraph(originalNotes);
        PureRandomWalkWithRandomStartNode pureRandomWalkArrangement = new PureRandomWalkWithRandomStartNode(NoteRepresentation.Simplified);
        List<Note> arrangementNotes = pureRandomWalkArrangement.generateArrangement(graph, originalNotes.size());
        pureRandomWalkArrangement.addNotesToFile(arrangementNotes, filename, 1);

        UndirectedGraphSimpleNotesCreation arrangementSimpleNotesCreation = new UndirectedGraphSimpleNotesCreation();
        Graph<String, String> arrangementGraph = arrangementSimpleNotesCreation.addNotesToGraph(arrangementNotes);

        graphSimpleNotesCreation.displayGraph(arrangementNotes, filename + "- aranżacja");
        List<Double> originalMetrics = graphSimpleNotesCreation.getGraphCharacteristics(graph);
        List<Double> arrangementMetrics = graphSimpleNotesCreation.getGraphCharacteristics(arrangementGraph);

        EdgeDegreeRandomWalkComparison.calculateAndDisplayDistance(graphSimpleNotesCreation, graph, arrangementSimpleNotesCreation, arrangementGraph);
    }
}
