package pl.edu.wat.wcy.isi.szymonm.phd.visualisation.arrangement;

import edu.uci.ics.jung.algorithms.metrics.Norm;
import edu.uci.ics.jung.graph.Graph;
import pl.edu.wat.wcy.isi.szymonm.phd.enums.graphs.NoteRepresentation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.structure.DirectedGraphStandardNotesCreation;
import pl.edu.wat.wcy.isi.szymonm.phd.graph.walk.VertexDegreesWeightWalkWithMaxDegreeStartNode;
import pl.edu.wat.wcy.isi.szymonm.phd.musicxml.Note;

import java.util.List;

public class WeightedDegreeRandomWalkArrangement {

    public static void main(String[] args) throws Exception {
        String filename;
        if(args.length == 0)
            filename = "HelloWorld.xml";
        else
            filename = args[0];

        DirectedGraphStandardNotesCreation digraphStandardNotesCreation = new DirectedGraphStandardNotesCreation();
        List<Note> originalNotes = digraphStandardNotesCreation.getNotesFromFile(filename);
        digraphStandardNotesCreation.displayGraph(originalNotes, filename);

        Graph<String, String> graph = digraphStandardNotesCreation.addNotesToGraph(originalNotes);
        VertexDegreesWeightWalkWithMaxDegreeStartNode pureRandomWalkArrangement
                = new VertexDegreesWeightWalkWithMaxDegreeStartNode(NoteRepresentation.Standard);
        List<Note> arrangementNotes = pureRandomWalkArrangement.generateArrangement(graph, originalNotes.size());
        pureRandomWalkArrangement.addNotesToFile(arrangementNotes, filename, 1);

        DirectedGraphStandardNotesCreation arrangementStandardNotesCreation = new DirectedGraphStandardNotesCreation();
        Graph<String, String> arrangementGraph = arrangementStandardNotesCreation.addNotesToGraph(arrangementNotes);

        digraphStandardNotesCreation.displayGraph(arrangementNotes, filename + "- aranżacja");

        EdgeDegreeRandomWalkComparison.calculateAndDisplayDistance(digraphStandardNotesCreation, graph, arrangementStandardNotesCreation, arrangementGraph);
    }
}
